/* $Id: ReadTemper.java,v 1.1 2005/09/21 10:37:50 mit Exp $ */
/* ReadTemper.java v0.1 */
import java.io.*;
import java.net.*;
import java.util.*;

public class ReadTemper {
    private final int Oct = 12;
    private static Vector temper;
    private static String Error;
    private static int count;

    public ReadTemper(URL url) {
	int m, len = Oct+2; // oct+2
	double[] tmp = new double[Oct];
	String line, s, name = "", type = "";
	StringTokenizer tk;
	Error = "";
	Temperament T;
	temper = new Vector();

	try {
	    BufferedReader bf = 
		new BufferedReader(new InputStreamReader(url.openStream()));
	    count = 0;
	    while( (line = bf.readLine() ) != null) {
		tk = new StringTokenizer(line, ",");
		m = tk.countTokens();
		if (m != len)
                    Error = "Data error:"+count;

		for(int j = 0; j < len; j++) { // m
                    try {
                        s = tk.nextToken();
			switch (j) {
			case 0:
			    name = s;
			    break;
			case 1:
			    type = s;
			    break;
			default:
			    tmp[j-2] = Double.valueOf(s).doubleValue();
			}
		    }
		    catch (NoSuchElementException e) {
                        Error = "No Token:"+count;
                    }
                    catch (Exception e) {
                        Error = "Token over:"+count;
                    }
                }
		T = new Temperament(name, type, tmp);
		temper.addElement(T);
		count++;
	    }
            bf.close();
        } catch (FileNotFoundException e) {
            Error = "Not found.";
        } catch (IOException e) {
            Error = "Not Open.";
        }
    }
    
    public static int getCount() {
	return count;
    }
    public static Vector getTemper() {
	return temper;
    }
    public static String getError() {
	return Error;
    }
}