/* $Id: Temperament.java,v 1.3 2005/09/21 10:37:50 mit Exp $ */
/* Temperament 2.5 */

public class Temperament {
    static final int OCT = 12; 
    private String temp, sw;
    private double[] cent = new double[OCT];
    private double[] work = new double[OCT];
    
    public Temperament() {
	setTemperament("","",0,0,0,0,0,0,0,0,0,0,0,0);
    }
    public Temperament(String t_name, String s,
    		      double a, double b, double c, double d, 
		      double e, double f, double g, double h,
		      double i, double j, double k, double l) {
	setTemperament(t_name, s, a,b,c,d,e,f,g,h,i,j,k,l);
    }
    public Temperament(String t_name, String s, double[] keys) {
    	setTemperament(t_name, s, keys);
    }
    public void setTemperament(String t_name, String s,
    			      double a, double b, double c, double d,
			      double e, double f, double g, double h,
			      double i, double j, double k, double l) {
	temp = t_name;
	sw = s;
	cent[0] = a;
	cent[1] = b;
	cent[2] = c;
	cent[3] = d;
	cent[4] = e;
	cent[5] = f;
	cent[6] = g;
	cent[7] = h;
	cent[8] = i;
	cent[9] = j;
	cent[10] = k;
	cent[11] = l;
    }
    public void setTemperament(String t_name, String s, double[] keys) {
    	temp = t_name;
	sw = s;
	for (int i = 0; i < OCT; i++)
	    cent[i] = keys[i];
    }
    public String getTemp() {
	return temp;
    }
    public String getSw() {
    	return sw;
    }
    public double getCent(int n) {
	return (n < 0 || n >= OCT) ? -1200 : cent[n];
    }
    public double[] getTemperament() {
	return cent;
    }
    public double[] getTemper() {
        ch_tmp();
        cent_();     // 100*i
        return work;
    }
    public double[] getTemperd() {
	ch_tmp();
	return work;
    }
    public String toString() {
	StringBuffer sb = new StringBuffer(96);
	sb.append(temp).append(",");
	sb.append(sw).append(",");
	for (int i = 0; i < OCT; i++) {
	    sb.append(cent[i]);
	    if (i < OCT-1)
		sb.append(",");
	}
	sb.append("\n");

	return sb.toString();
    }
    public void ch_tmp() {
        char sw = getSw().charAt(0);

        switch(sw) {
        case 'c':                // c~h
            c_set();
            break;
        case 'C':                // c~h-100
            C_set();
            break;
        case 'F':                // freq.
            f_set();
            break;
        default:
            C_set();
        }
    }
    public void c_set() {
	for (int i = 0; i < OCT; i++)
            work[i] = cent[i];
        a_shift();
    }
    public void C_set() {
        for (int i = 0; i < OCT; i++)
            work[i] = cent[i] - i*100;
        a_shift();
    }
    public void f_set() {
        for (int i = 0; i < OCT; i++)
            work[i] = f2c(cent[i], i);
    }
    public void a_shift() {
        double sa = work[9];       // a=0cent
	if (sa == 0)
	    return;
        for (int i = 0; i < OCT; i++)
            work[i] -= sa;
    }
    public void cent_() {
        for (int i = 0; i < OCT; i++)
            work[i] += i*100;
    }
    public double f2c(double f, int n) {
	return 1200*Math.log(f/440d)/Math.log(2)-(n-9)*100;
    }
}
