/* $Id: interval.java,v 1.15 2013/01/18 08:04:37 mit Exp $ */
/* interval.java v2.0 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.DecimalFormat;

public class interval extends Applet 
    implements  AdjustmentListener, ItemListener, ActionListener,
		MouseListener, MouseMotionListener
{
    final int A49 = 440; 
    final int Oct = 12;
    final int KB = 88;
    final int Cent = 1200;
    final double MC = Cent/Math.log(2);
    final double RAD = Math.PI/180d;

    Interval IN;
    Vector T;
    Graphics gi;
    Image im;
    Font Fnt, Fns;
    DecimalFormat df1;

    double[] Equal;
    double[] Work;
    boolean CBsw;         // cent/beats
    boolean GTsw;         // graph./text
    int W;               // canvas-w
    int H;               //  "    -h
    int HC;              // h/2
    int FNT;             // font size
    int CV, CH;          // scr. cent
    int BV, BH;          // scr. beat
    int Cpo;             // position cent
    int Bpo;             // position beat
    int Cst = 40-1;      // c 28?
    int KEY;             // key num
    int Tnum = 50;       // temper. max?
    int Radius;
    double VolC = 1;     // volume cent
    double VolB = 1;     // " beat
    String Error;
    String[] Filenm;
    static final String[] Keynm = {
	"C","Cis","D","Es","E","F","Fis","G","Gis","A","B","H","C"};
    private static final long serialVersionUID = 1L;

    private Canvas can;
    private TextArea taA;
    private Scrollbar sbV, sbH;
    private Checkbox[] cbI;    // interval
    private Choice chFile;     // file
    private Choice chTemp;     // temper.
    private Choice chKey;      // key
    private Choice chJPA;
    private Button btCB;       // cent/beats
    private Button btB;        // X
    private Button btM;        // /
    private Button btTG;       // text/graphe.
    private Button btCS;       // cent-set
    private Button btIS;       // inter.set
    private Button btP;        // position
    private TextField tfC;     // cent
    private TextField tfD;     // denomi
    private TextField tfN;     // numera
    private Panel deck;        // for card
    private CardLayout card;   // in card
    private Panel PN, PW, PE, PS;

    public void init() {
	init_set();
	buildLayout();
	init_start();
    }
    public void init_set() {
	df1 = new DecimalFormat("#0.000");
	T = new Vector();
	IN = new Interval();
	pre_set();
    }
    public void buildLayout() {
	FNT = Integer.parseInt(getParameter("font"));
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	Fns = new Font("MonoSpaced", Font.PLAIN, FNT);
	setFont(Fnt);

        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	deck = new Panel();
	card = new CardLayout();
	deck.setLayout(card);
	//----------------------------------north

	PN = new Panel();         // top
	PN.setLayout(new GridLayout(2,1,0,0));
	add(PN, "North");

        Panel p1 = new Panel();   // top 1/2
        p1.setLayout(new FlowLayout());
        PN.add(p1);

        Panel p2 = new Panel();   // top 2/2
        p2.setLayout(new FlowLayout());
        PN.add(p2);

        String fn = getParameter("all_f");
        int af = (fn == null) ? 0 : Integer.parseInt(fn);
        Filenm = new String[af];
        for (int i = 0; (fn = getParameter("temper_f"+i)) != null; i++)
            Filenm[i] = fn;
        chFile = new Choice();
        for (int i = 0; i < Filenm.length; i++)
            chFile.addItem(Filenm[i]);
        p1.add(chFile);
        chFile.addItemListener(this);

        chTemp = new Choice();
	chTemp.addItem(getTempName(0)); // only 0
        chTemp.addItemListener(this);
        p1.add(chTemp);

	p1.add(new Label(":"));

	btTG = new Button("Graph.");
	btTG.addActionListener(this);
        p1.add(btTG);
	//-------------------------p1/p2

	p2.add(new Label("Key"));

	btCS = new Button("C-set");
	btCS.addActionListener(this);
        p2.add(btCS);

	tfC = new TextField(6);
	tfC.setFont(Fns);
	tfC.setEditable(true);
	tfC.addActionListener(this);
	p2.add(tfC);

	int len = IN.getLen();
	chKey = new Choice();
	for (int i = 0; i < len; i++)
	    chKey.addItem(Keynm[i]+":"+IN.getName(i));
	chKey.addItemListener(this);
	p2.add(chKey);

	int wind = 3;
	tfD = new TextField(wind);
	tfD.setFont(Fns);
	tfD.setEditable(true);
	tfD.addActionListener(this);
	p2.add(tfD);

	tfN = new TextField(wind);
	tfN.setFont(Fns);
	tfN.setEditable(true);
	tfN.addActionListener(this);
	p2.add(tfN);

	btIS = new Button("I-set");
	btIS.addActionListener(this);
        p2.add(btIS);

	p2.add(new Label(":"));

	btCB = new Button("Cent");
	btCB.addActionListener(this);
        p2.add(btCB);

	btB = new Button("X");
        btB.addActionListener(this);
        p2.add(btB);

	btM = new Button("/");
        btM.addActionListener(this);
        p2.add(btM);
	//---------------------------east

	PE = new Panel();
        PE.setLayout(new GridLayout(len+2,1,0,0));
        add(PE, "East");

	chJPA = new Choice();
	for (int i = 0; i < IN.getTnum(); i++)
	    chJPA.addItem(IN.getTemper(i));
	PE.add(chJPA);
        chJPA.addItemListener(this);

	btP = new Button("Position");
        btP.addActionListener(this);
        PE.add(btP);

	cbI = new Checkbox[len];
        for (int i = 0; i < len; i++) {
            boolean sw = (i == 0 || i == 4 || i == 7 || i == 12) 
		? true : false;
	    cbI[i] = new Checkbox(IN.getName(i), sw);
	    IN.setInte(i, sw);
            PE.add(cbI[i]);
            cbI[i].addItemListener(this);
        }
	//------------------------------------west

	PW = new Panel();
	PW.setLayout(new GridLayout(1,1,0,0));
	add(PW, "West");

	sbV = new Scrollbar(Scrollbar.VERTICAL,0,0,0,0);
	sbV.addAdjustmentListener(this);
	PW.add(sbV);
	//------------------------------------south

	PS = new Panel();
	PS.setLayout(new GridLayout(1,1,0,0));
	add(PS, "South");

	sbH = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,0);
        sbH.addAdjustmentListener(this);
	PS.add(sbH);
	//------------------------------------center

        can = new MyCanvas();
        can.addMouseListener(this);
        can.addMouseMotionListener(this);

	Panel card1 = new Panel();
        card1.add(can);
	deck.add(card1, "card1");

	taA = new TextArea("", 15, 45, TextArea.SCROLLBARS_BOTH);
	taA.setFont(Fns);
	taA.setEditable(false);

	ScrollPane card2 = new ScrollPane();
	card2.add(taA);
	deck.add(card2, "card2");

	add(deck, "Center");
    }
    public void pre_set() {
	Equal = new double[Oct];
	for (int i = 0; i < Oct; i++)    // +equal
            Equal[i] = i*100;

	temper_select(0);                // temper
	addTempEqual();
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;

	Radius = (int)(H/8d);
	HC = H/2;
	can.setSize(W, H);
	im = createImage(W, H);
        gi = im.getGraphics();
        gi.setFont(Fnt);

	init_cb();
    }
    public Dimension getCanvasD() {
	Dimension du = PN.getSize();
	Dimension dr = PE.getSize();
	Dimension dl = PW.getSize();
	Dimension dd = PS.getSize();
	Dimension da = getSize();
	int cw = da.width-(dr.width+dl.width);
	int ch = da.height-(du.height+dd.height);
	Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_start() {
	Work = new double[Oct];

	set_enabled();
        read_data(Filenm[0]);
    }
    public void set_enabled() {
	sbH.setEnabled(!GTsw);
	sbV.setEnabled(!GTsw);
	btB.setEnabled(!GTsw);  // X
	btM.setEnabled(!GTsw);  // /
	btP.setEnabled(!GTsw);  // posision
	chJPA.setEnabled(CBsw); // 3_temp.
    }
    //
    public void read_data(String fn) {
        chTemp.removeAll();  // remove cht

	read_file(fn);
	addTempEqual();

	Tnum = (Tnum < 0) ? 0 : T.size();
	for (int i = 0; i < Tnum; i++)   // insert cht
	    chTemp.insert(getTempName(i), i);

	Work = getTempDatas(0);
	disp_tf();
    }
    public void read_file(String fn) {
	try {
            URL url = new URL(getDocumentBase(), fn);
            ReadTemper rt = new ReadTemper(url);

            T = rt.getTemper();
            Tnum = rt.getCount();
	    Error = rt.getError();
	} catch(Exception e) {
            Error = "File read error.";
        }
    }
    public void addTempEqual() {
	T.addElement(new Temperament("Equal", "C", Equal));
    }
    public double[] getTempDatas(int num) {
	return ((Temperament)T.elementAt(num)).getTemperd();
    }
    public String getTempName(int num) {
	return ((Temperament)T.elementAt(num)).getTemp();
    }
    //
    public void mousePressed(MouseEvent m) {}
    public void mouseReleased(MouseEvent m) {}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}
    public void mouseClicked(MouseEvent m) {}
    public void mouseMoved(MouseEvent me) {}
    public void mouseDragged(MouseEvent me) {
	if (CBsw) {
	    BV = me.getY();
	    BH = me.getX();

	    sbV.setValue(BV);
	    sbH.setValue(BH);
	} else {
	    CV = me.getY()-H/4;
	    CH = me.getX()-W/4;

	    sbV.setValue(CV);
	    sbH.setValue(CH);
	}

	can.repaint();
    }
    //
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (!GTsw) {                  // scrollbar if graph.
	    if (CBsw) {               // beat
		BV = sbV.getValue();
		BH = sbH.getValue();
	    } else {                 // cent
		CV = sbV.getValue();
		CH = sbH.getValue();
	    }

	    can.repaint();
	}
    }
    //
    public void itemStateChanged(ItemEvent e) {
	for (int i = 0; i < IN.getLen(); i++)    // interval
	    IN.setI(i, cbI[i].getState() ? true : false);

	if (e.getSource() == chFile)             // file
	    read_data(chFile.getSelectedItem());

        if (e.getSource() == chTemp) {           // temper.
	    Work = getTempDatas(chTemp.getSelectedIndex());
	    disp_tf();
	}

	if (e.getSource() == chKey) {           // key
	    KEY = chKey.getSelectedIndex();
	    disp_tf();
	}

	if (e.getSource() == chJPA) {         // 3_temp.
	    temper_select(chJPA.getSelectedIndex());
	    disp_tf();
	}

	disp_select();
    }
    //
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btTG) {      // text/graph.
	    GTsw = !GTsw;
	    btTG.setLabel(GTsw ? "Text" : "Grap.");
	    card.next(deck);
	}
	else if (e.getSource() == btCB) { // cent/beats
	    CBsw = !CBsw;
	    cb_set();
	}
	else if (e.getSource() == btCS)   // cent set
	    set_cent();
	
	else if (e.getSource() == btIS)   // inter set
	    set_inter();

	else if (e.getSource() == btP) {  // position
	    if(CBsw) 
		set_beat_position();
	    else 
		set_cent_position();
	}
	else if (e.getSource() == btB) // X
	    set_value(true);
	else if (e.getSource() == btM) // /
	    set_value(false);

	set_enabled();
	disp_select();
    }
    public void set_value(boolean sw) {
	double by = Math.sqrt(2);
	if (CBsw)
	    VolB = (sw) ? VolB*by : VolB/by;
	else
	    VolC = (sw) ? VolC*by : VolC/by;
    }
    public void set_beat_position() {
	Bpo++;
	if (Bpo > 2)
	    Bpo = 0;
    }
    public void set_cent_position() {
	Cpo++;
	if (Cpo > 2)
	    Cpo = 0;
    }
    //
    public void temper_select(int num) {
	IN.initWork(num);
    }
    public void init_cb() {
	sbV.setValues(H/4, 10, 0, H/2+10);
	sbV.setBlockIncrement(5);
	sbH.setValues(W/2, 10, 0, W+10);
	sbH.setBlockIncrement(5);
	CV = BV = sbV.getValue();
	CH = BH = sbH.getValue();
    }
    public void cb_set() {
	btCB.setLabel(CBsw ? "Beats" : "Cent");

	if (CBsw) {
	    sbV.setValue(BV);
	    sbH.setValue(BH);
	} else {
	    sbV.setValue(CV);
	    sbH.setValue(CH);
	}
    }
    public void disp_select() {
	if (GTsw) {
	    if (!Error.equals("")) 
		taA.setText(Error);
	    else
		rewrite();
	} else
	    can.repaint();
    }
    public void disp_tf() {
	tfC.setText((float)Work[KEY%Oct]+"");

	tfD.setText(IN.getWorkL(KEY)+"");
	tfN.setText(IN.getWorkH(KEY)+"");
    }
    public void set_cent() {
	String setc = tfC.getText();
	if (setc.equals("")) {
	    tfC.setText("no input");
	    return;
	}
	try {
	    double sc = Double.valueOf(setc).doubleValue();
	    Work[KEY%Oct] = sc;
	}
	catch (NumberFormatException e) {
	    tfC.setText("input error");
	}
    }
    public void set_inter() {
	String setid = tfD.getText();
	String setin = tfN.getText();
	if (setid.equals("")) {
	    tfD.setText("no");
	    return;
	}
	if (setin.equals("")) {
	    tfN.setText("no");
	    return;
	}
	try {
	    int sid = Integer.parseInt(setid);
	    int sin = Integer.parseInt(setin);
	    IN.setWorkL(KEY, sid);
	    IN.setWorkH(KEY, sin);
	}
	catch (NumberFormatException e) {
	    tfD.setText("error");
	}
    }
    public void rewrite() {
	StringBuffer sb = new StringBuffer("Key:    [Hz]: [Cent]");
	String sp = ": ";
	double bc;
	int kn, i0, d, sum = IN.getSum();
	for (int j = 0; j < sum; j++)
	    sb.append(sp).append(IN.getSname(j));
	sb.append(CBsw ? "(beats)" : "(cent)").append("\n");
	for (int i = 0; i < Oct; i++) {
	    kn = Cst+i;
	    sb.append(sform(Keynm[i], 3)).append(sp);
	    sb.append(dform(ctoh(kn))).append(sp);

	    i0 = CBsw ? 0 : i*100;
	    sb.append(dform(Work[i]+i0));
	    for (int j = 0; j < sum; j++) { 
		d = IN.getSum(j);
		bc = CBsw ? get_beats(kn, j) : get_cent(i, d)+d*100;
		sb.append(sp).append(dform(bc));
	    }
	    sb.append("\n");
	}

	taA.setText(sb.toString());
    }
    public String dform(double num) {
	return df1.format((float)num);
    }
    public String sform(String n, int max){
        StringBuffer str = new StringBuffer(n);
        StringBuffer ems = new StringBuffer();
        String emp = "_";
        if (str.length() < max) {
            for (int i = 0; i < max-str.length(); i++)
                ems.append(emp);
            str.insert(0, ems);  // front ems
        }

        return str.toString();
    }
    public double ftoc(double f, int key) {
	return MC*Math.log(f/getFreq(key));
    }
    public double ctoh(int key) {
	int k = (key-3)%Oct;    // c=-3
	return getFreq(key)*Math.pow(2, Work[k]/Cent);
    }
    public double getFreq(int key) {
        return A49*Math.pow(2, (key-48)/(double)Oct); // 49-1
    }
    public double get_beats(int key, int n) {
	if (key+n >= KB)
	    return 0;
	int in = IN.getSum(n);

	return ctoh(key+in)*IN.getWorkH(in)-
	    ctoh(key)*IN.getWorkL(in);
    }
    public double get_cent(int num, int dif) {
	int c1 = num+dif;
	if (num >= Oct)
	    num %= Oct;
	if (c1 >= Oct)
	    c1 %= Oct;

	return Work[c1]-Work[num];
    }
    public int n2c(int num, int dif) {
        return (dif*num)%Oct;
    }
    public Point p_line(int ang, double r, double x, double y) {
	Point p = new Point((int)((r+10)*Math.cos(RAD*ang)+x),
			    (int)((r+10)*Math.sin(RAD*ang)+y));
	return p;
    }
    public Point p_moji(int ang, double r, double x, double y) {
	Point p = new Point((int)((r+24)*Math.cos(RAD*ang)+x-5),
			    (int)((r+24)*Math.sin(RAD*ang)+y+5));
	return p;
    }
    //---

    class Interval {
	static final int JUST = 0;
	static final int PYTH = 1;
	static final int ARIS = 2;
	static final int DEN = 0; // ʬ denominator
	static final int NUM = 1; // ʬ numerator

	final int[] R = {255,255,255,255,128,  0,  0,  0,  0,  0, 85,170,255};
	final int[] G = {  0, 85,170,255,255,255,215,170, 85,  0,  0,  0,  0};
	final int[] B = {  0,  0,  0,  0,  0, 85,170,255,255,255,255,255,170};
	final int[][] Just = {
	    {1,1},{16,15},{10,9},{6,5},{5,4},{4,3},{45,32},
	    {3,2},{8,5},{5,3},{16,9},{15,8},{2,1}};
	final int[][] Pyth = {
	    {1,1},{256,243},{9,8},{32,27},{81,64},{4,3},{1024,729},
	    {3,2},{128,81},{27,16},{16,9},{243,128},{2,1}};
	final int[][] Aris = {
	    {1,1},{16,15},{9,8},{6,5},{5,4},{4,3},{64,45},
	    {3,2},{8,5},{27,16},{9,5},{15,8},{2,1}};
	final String[] Temper = {
	    "Just Int.","Pytha.","Arist."};
	/* "Just Intonation","Pythagoras","Aristoxenos"}; */
	final String[] Intnm = {
	    "Unison","mi.2nd","Mj.2nd","mi.3rd","Mj.3rd","P.4th","Aug.4th",
	    "P.5th","mi.6th","Mj.6th","mi.7th","Mj.7th","Octave"};

	int len = this.getLen();
	boolean[] Inte = new boolean[len];
	int[] Sum = new int[len];
	int[][] Work = new int[len][2];
	Color[] IC = new Color[len];

	public Interval() {
	    initColor();
	}
	public void setI(int n, boolean sw) {
	    Inte[n] = sw;
	}
	public boolean getI(int n) {
	    return Inte[n];
	}
	public int getLen() {
	    return Intnm.length;
	}
	public String getName(int n) {
	    return Intnm[n];
	}
	public int getSum() {
	    int sum = 0;
	    for (int i = 0; i < this.getLen(); i++) {
		if (this.Inte[i])
		    Sum[sum++] = i;
	    }
	    return sum;
	}
	public int getSum(int n) {
	    return Sum[n];
	}
	public String getSname(int n) {
	    return Intnm[Sum[n]];
	}
	public void setInte(int n, boolean sw) {
	    Inte[n] = sw;
	}
	public boolean getInte(int n) {
	    return Inte[n];
	}
	public void initWork(int n) {
	    for (int i = 0; i < this.getLen(); i++) {
		switch (n) {
		case JUST:
		    Work[i][DEN] = Just[i][DEN];
		    Work[i][NUM] = Just[i][NUM];
		    break;
		case PYTH:
		    Work[i][DEN] = Pyth[i][DEN];
		    Work[i][NUM] = Pyth[i][NUM];
		    break;
		case ARIS:
		    Work[i][DEN] = Aris[i][DEN];
		    Work[i][NUM] = Aris[i][NUM];
		    break;
		default:
		}
	    }
	}
	public int getWorkL(int n) {
	    return Work[n][DEN];
	}
	public int getWorkH(int n) {
	    return Work[n][NUM];
	}
	public void setWorkL(int n, int num) {
	    Work[n][DEN] = num;
	}
	public void setWorkH(int n, int num) {
	    Work[n][NUM] = num;
	}
	public int getTnum() {
	    return Temper.length;
	}
	public String getTemper(int n) {
	    return Temper[n];
	}
	public void initColor() {
	    for (int i = 0; i < this.getLen(); i++)
		IC[i] = new Color(R[i],G[i],B[i]);
	}
	public Color getColor(int n) {
	    return IC[n];
	}
    }
    //---

    class MyCanvas extends Canvas {
	private static final long serialVersionUID = 1L;
        public void update(Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
	    paintI();
            g.drawImage(im, 0, 0, this);
        }
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);

	if (CBsw)
	    disp_beats(gi);
	else
	    disp_cent(gi);
    }
    //
    public void disp_beats(Graphics g) {
	int sum = IN.getSum();
	double dw = (double)BH/Oct;
	double dh = (double)BV/Oct;
	double rw = (double)(W-BH)/(sum-1); // Oct
	double rh = (double)BV/(sum-1);     // no 

	disp_inteb_name(g, sum);
	disp_key_name(g, dw, dh);
	disp_base_line(g, sum, rw, rh);

	double x0 = 0, y0 = 0;
	double kx, ky, dx, dy, b, db;
	for (int j = 0; j < Oct; j++) { // key
	    kx = j*dw;
	    ky = j*dh+HC;
	    for (int i = 0; i < sum; i++) { // interval
		dx = kx+i*rw;
		dy = ky-i*rh;
		b = get_beats(Cst+j, i)*VolB;
		db = dy-b;

		g.setColor((b < 0) ? Color.cyan : Color.magenta); // +-
		g.drawLine((int)dx, (int)dy, (int)dx, (int)db);

		if (i == 0) {
		    x0 = dx;
		    y0 = db;
		}
		g.setColor(IN.getColor(j));
		g.drawLine((int)x0, (int)y0, (int)dx, (int)db);
		x0 = dx;
		y0 = db;
	    }
	}
    }
    public void disp_base_line(Graphics g, int sum, double rw, double rh) {
	double jw, jh, jx, jy;
	for (int j = 0; j < sum; j++) {
	    jw = j*rw;
	    jh = HC-j*rh;
	    jx = BH+jw;
	    jy = BV+jh;

	    g.setColor(Color.darkGray);
	    g.drawLine((int)jw, (int)jh, (int)jx, (int)jy);

	    g.setColor(Color.orange);
	    g.drawString(j+"", (int)jx-5, (int)jy+5);
	}
    }
    public void disp_inteb_name(Graphics g, int sum) {
	if (Bpo == 2)
	    return;

	int bp;
	g.setColor(Color.orange);
	for (int i = 0; i < sum; i++) {
	    bp = (Bpo == 1) ? H-i*FNT-FNT : (sum-i)*FNT; //
	    g.drawString(i+" "+IN.getSname(i), 1, bp);
	}
    }
    public void disp_key_name(Graphics g, double dw, double dh) {
	int ix, iy;
	for (int i = 0; i < Oct; i++) { // key
	    ix = (int)(i*dw);
	    iy = (int)(i*dh)+HC;

	    g.setColor(Color.white);
	    g.drawString(Keynm[i], ix, iy+14);

	    g.setColor(Color.darkGray);
	    g.drawLine(ix, iy, W-BH+ix, iy-BV);
	}
    }
    //
    public void disp_cent(Graphics g) {
	int sum = IN.getSum();
	double xs = CH/(double)(sum+1); // +1
	double ys = CV/(double)(sum+1); // not 0

	disp_base_circle(g);

	int d;
	double x0 = Radius*2+Radius/2, y0 = Radius*2;
	for (int j = 0; j < sum; j++) {
	    d = IN.getSum(j);

	    g.setColor(IN.getColor(j));
	    disp_intec_name(g, j, sum);
	    disp_circle(g, d, j, x0, y0);

	    x0 += xs;
	    y0 += ys;
	}
    }
    public void disp_intec_name(Graphics g, int j, int sum) {
	if (Cpo == 2)
	    return;

	int cp = (Cpo == 1) ? H-(sum-j)*FNT : j*FNT+FNT;
	g.drawString(IN.getSname(j), 1, cp);
    }
    public void disp_circle(Graphics g, int d, int j, double x, double y) {
	Point p;
	int ang = -90; // 12~
	int x0 = 0, y0 = 0, dc;

	for (int i = 0; i <= Oct; i++) {
	    dc = (int)(get_cent(n2c(i,7), d)*VolC);
	    p = p_line(ang, Radius+dc, x, y);

	    if (i != 0)
		g.drawLine(x0, y0, p.x, p.y);

	    x0 = p.x;
	    y0 = p.y;
	    ang += 30;
	}

	disp_cross(g, (int)x, (int)y);
    }
    public void disp_cross(Graphics g, int x, int y) {
	int l = 2;

	g.setColor(Color.gray);
	g.drawLine(x-l, y, x+l, y);
	g.drawLine(x, y-l, x, y+l);
    }
    public void disp_base_circle(Graphics g) {
	Point p;
	int ang = -90;         // 12~
	int x1 = 0, y1 = 0;
   	double x0 = W-2*Radius, y0 = 2*Radius;

	g.setColor(Color.gray);
	for (int i = 0; i <= Oct; i++) { // base circle
	    p = p_line(ang, Radius, x0, y0);
	    if (i != 0)
		g.drawLine(x1, y1, p.x, p.y);
	    x1 = p.x; 
	    y1 = p.y;
	    ang += 30;
	}

	ang = -90; // 12~
	g.setColor(Color.lightGray);
	for (int i = 0; i < Oct; i++) { // key c~c
	    p = p_moji(ang, Radius, x0, y0);
	    g.drawString(Keynm[n2c(i, 7)], p.x, p.y);
	    ang += 30;
	}
    }
}